<?php
/**
 * @version		$Id$
 * @author		Nguyen Lu Vinh
 * @package		FunReCaptcha
 * @copyright	Copyright (C) 2009 All For You. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

/**
 * FunReCaptcha Controller
 * @author Nguyen
 *
 */
class FunReCaptchaController extends JController
{
	function __construct($config = array())
	{
		parent::__construct($config);
		$this->registerTask('add', 'edit');
		$this->registerTask('unblock', 'block');
		$this->registerTask('apply', 'save');
	}
	
	function display()
	{
		JRequest::setVar('view', 'items');
		parent::display();
	}
	
	function edit()
	{
		JRequest::setVar('view', 'item');
		parent::display();
	}
	
	function save()
	{
		JRequest::checkToken() or jexit('Invalid Token');
		
		$post = JRequest::get('post');
		$cid = JRequest::getVar('cid', Array(0), 'post', 'array');
		$post['id'] = (int)$cid[0];
		
		$model = $this->getModel('Item');
		if ($model->store($post)) {
			if ($this->getTask() == 'apply') {
				$link = 'index.php?option=com_funrecaptcha&task=edit&cid[]='.$model->getId(); 
			} else {
				$link = 'index.php?option=com_funrecaptcha';
			}
			$msg = JText::_('Item Saved');
			$type = 'message'; 	
		} else {
			$link = 'index.php?option=com_funrecaptcha&task=edit&cid[]='.$model->getId();
			$msg = JText::_('Error Saving Item').': '.$model->getError();
			$type = 'notice';
		}
		$this->setRedirect($link, $msg, $type);
	}
	
	function cancel()
	{
		$this->setRedirect('index.php?option=com_funrecaptcha');
	}
	
	function remove()
	{
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to delete' ) );
		}

		$model = $this->getModel('Item');
		if(!$model->delete($cid)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_funrecaptcha' );
	}
	
	function block()
	{
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}

		$model = $this->getModel('Item');
		if(!$model->enable($cid, $this->getTask() == 'unblock' ? 1 : 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_funrecaptcha' );
	}
}