<?php
/**
 * @version		$Id$
 * @author		Nguyen Lu Vinh
 * @package		FunRecaptcha
 * @copyright	Copyright (C) 2009 All For You. All rights reserved.
 * @license		GNU/GPL
 */

defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.model');

class FunRecaptchaModelItem extends JModel
{
	/**
	 * @var int
	 */
	var $_id = null;
	
	/**
	 * @var object
	 */
	var $_data = null;
	
	/**
	 * Load the model state from session or not
	 * 
	 * @var unknown_type
	 */
	var $_loadState = true;
	
	/**
	 * The model context to save data to session
	 * 
	 * @var unknown_type
	 */
	var $_context = null;
	
	function __construct($config)
	{
		parent::__construct($config);
		
		if (array_key_exists('loadState', $config))  {
			$this->_loadState = (boolean)$config['loadState'];
		}
		
		// Set the model context to save data to session
		if (array_key_exists('context', $config)) {
			$this->_context = $config['context'];
		} else {
			$this->_context = $option.'.'.$this->getName().'.';
		}
		
		$id = JRequest::getInt('id', 0);
		$array = JRequest::getVar('cid', Array($id), '', 'array');
		$this->setId((int)$array[0]);
	}
	
	function setId($id)
	{
		$this->_id = $id;
		$this->_data = null;
	}
	
	function getId()
	{
		return $this->_id;
	}
	
	function &getData()
	{
		if (!$this->_loadData()) {
			$this->_initData();
		}
		return $this->_data;
	}
	
	/**
	 * Method to store the item
	 * 
	 * @param array store data
	 * @return boolean true on success
	 */
	function store($data)
	{
		$row =& $this->getTable();

		// Bind the form fields to the table
		if (!$row->bind($data)) {
			$this->setError($row->getError());
			return false;
		}
				
		// Make sure the table is valid
		if (!$row->check()) {
			$this->setError($row->getError());
			// Save table data in the session for later use
			$app = &JFactory::getApplication();
			$data['params'] = $row->params;
			$app->setUserState($this->_context.'data', JArrayHelper::toObject($data));
			return false;
		}

		// Store the table to the database
		if (!$row->store()) {
			$this->setError($row->getError());
			return false;
		}
		
		// Set the id so we can get the job id have just insert by getId() method
		$this->setId($row->id);
		return true;
	}
	
	function delete($cid = array())
	{
		if (empty($cid) && $this->_id) {
			$cid = array($this->_id);
		}
		
		if (count($cid)) {
			JArrayHelper::toInteger($cid);
			$cids = implode(',', $cid);
			$query = 'DELETE FROM #__funrecaptcha'
				. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery($query);
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return true;
	}
	
	function enable($cid, $enable)
	{
		if (count($cid)) {
			JArrayHelper::toInteger($cid);
			$cids = implode(',', $cid);
			$query = 'UPDATE #__funrecaptcha'
				. ' SET enabled = '.(int)$enable
				. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery($query);
			if(!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return true;
	}
	
	function _loadData()
	{
		if (empty($this->_data)) {
			$query = 'SELECT *'
				. ' FROM #__funrecaptcha'
				. ' WHERE id = '.(int)$this->_id;
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			return (boolean)$this->_data;
		}
		return true;
	}
	
	function _initData()
	{
		if (empty($this->_data)) {
			$item = new stdClass();
			
			$item->id				= 0;
			$item->integrated_vars	= null;
			$item->checked_vars		= null;
			$item->rel_item_id		= null;
			$item->position			= null;
			$item->restore_fields	= null;
			$item->enabled			= 1;
			$item->params			= null;
			if ($this->_loadState) {
				$app = &JFactory::getApplication();
				$data = $app->getUserState($this->_context.'data', null);
				$app->setUserState($this->_context.'data', null);
				if ($data != null) {
					$item = &$data;
				}
			}
			$this->_data = $item;
		}
	}
}