<?php
/**
 * @version		$Id$
 * @author		Nguyen Lu Vinh
 * @package		FunReCaptcha
 * @copyright	Copyright (C) 2009 All For You. All rights reserved.
 * @license		GNU/GPL
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.model');

class FunReCaptchaModelItems extends JModel
{
	/**
	 * @var array
	 */
	var $_data = null;
	
	/**
	 * The total number of items
	 * @var int
	 */
	var $_total = null;
	
	/**
	 * @var object JPagination
	 */
	var $_pagination = null;
	
	/**
	 * save the user filter state or not
	 * @var boolean
	 */
	// var $_session = false;
	
	/**
	 * Context to save the user filter state
	 * @var string 
	 */
	var $_context = null;
	
	/**
	 * Constructor
	 * @param $config array
	 * @return null
	 */
	function __construct($config = array())
	{
		parent::__construct($config);
		
		$option = JRequest::getWord('option');
		$app = &JFactory::getApplication();
		
		/* if (array_key_exists('session', $config))  {
			$this->_session = (boolean)$config['session'];
		} */
		
		// Get the pagination request varialbes
		if (array_key_exists('context', $config)) {
			$this->_context = $config['context'];
		} else {
			$this->_context = $option.'.'.$this->getName().'.';
		}
		$limit			= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart = $app->getUserStateFromRequest($this->_context.'limitstart', 'limitstart', 0, 'int');
		/* if ($this->_session) {
			$limitstart = $app->getUserStateFromRequest($this->_context.'limitstart', 'limitstart', 0, 'int');
		} else {
			$limitstart = JRequest::getInt('limitstart', 0);
		} */
		
		// In case limit has been changed, adjust limitstart accordingly
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		// In case limitstart larger than items total, adjust limitstart accordingly
		$total = $this->getTotal();
		if ($total < $limitstart) {
			$limitstart = floor(($total- 1) / $limit) * $limit;
		}
		
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}
	
	/**
	 * Method to set model state variables, and restart the result
	 *
	 * @access	public
	 * @param	string	The name of the property
	 * @param	mixed	The value of the property to set
	 * @return	mixed	The previous value of the property
	 */
	function setState( $property, $value=null )
	{
		$this->_total		= null;
		$this->_data		= null;
		$this->_pagination	= null;
		return $this->_state->set($property, $value);
	}
	
	/**
	 * Method to get list of Object items
	 *
	 * @access public
	 * @return array
	 */
	function getData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}

	/**
	 * Method to get the total number of items
	 *
	 * @access public
	 * @return integer
	 */
	function getTotal()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

	/**
	 * Method to get a JPagination Object for the items list
	 *
	 * @return Object JPagination
	 */
	function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}
	
	/**
	 * Builder the query
	 * 
	 * @return string
	 */
	function _buildQuery()
	{
		$where = $this->_buildQueryWhere();
		$order = $this->_buildQueryOrderBy();
		
		$query = 'SELECT *'
			. ' FROM #__funrecaptcha'
			. $where
			. $order
		;
		return $query;
	}
	
	/**
	 * Build the search Query
	 * 
	 * @return string
	 */
	function _buildQueryWhere()
	{
		$where = array();
		if ($this->getState('filter.enabled') == 'T') {
			$where[] = 'enabled = 1';
		} else if ($this->getState('filter.enabled') == 'F') {
			$where[] = 'enabled = 0';
		}
		
		return ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );
	}
	
	/**
	 * Build the Order Query
	 * 
	 * @return string
	 */
	function _buildQueryOrderBy()
	{
		$app = &JFactory::getApplication();
		$orders = array('id', 'integrated_vars', 'checked_vars', 'rel_item_id', 'position', 'enabled');
		
		$filter_order		= $app->getUserStateFromRequest($this->_context.'filter_order', 'filter_order', 'id', 'cmd');
		$this->setState('list.ordering', $filter_order);
		$filter_order_Dir	= $app->getUserStateFromRequest($this->_context.'fitler_order_Dir', 'filter_order_Dir', 'ASC', 'word');
		$filter_order_Dir	= strtoupper($filter_order_Dir);
		$this->setState('list.direction', $filter_order_Dir);
		
		if ($filter_order_Dir != 'ASC' && $filtre_order_Dir != 'DESC') {
			$filter_order_Dir = 'ASC';
		}
		if (!in_array($filter_order, $orders)) {
			$filter_order = 'id';
		}
		return ' ORDER BY '.$filter_order.' '.$filter_order_Dir;
	}
}
?>