<?php
/**
 * @version		$Id$
 * @author		Nguyen Lu Vinh
 * @package		FunReCaptcha
 * @copyright	Copyright (C) 2009 All For You. All rights reserved.
 * @license		GNU/GPL
 */

defined('_JEXEC') or die('Restricted access');

class TableItem extends JTable
{
	/**
	 * Primary key
	 * 
	 * @var int
	 */
	var $id = null;
	
	/**
	 * @var string
	 */
	var $integrated_vars = null;
	
	/**
	 * @var string
	 */
	var $checked_vars = null;
	
	/**
	 * @var string
	 */
	var $rel_item_id = null;
	
	/**
	 * @var string
	 */
	var $position = null;
	
	/**
	 * @var string
	 */
	var $restore_fields = null;
	
	/**
	 * @var int
	 */
	var $enabled = null;
	
	/**
	 * @var string
	 */
	var $params = null;
	
	function __construct(&$db)
	{
		parent::__construct('#__funrecaptcha', 'id', $db);
	}
	
	/**
	* Overloaded bind function
	*
	* @acces public
	* @param array $hash named array
	* @return null|string	null is operation was satisfactory, otherwise returns an error
	* @see JTable:bind
	* @since 1.5
	*/
	function bind($array, $ignore = '')
	{
		if (key_exists( 'params', $array ) && is_array( $array['params'] ))
		{
			$registry = new JRegistry();
			$registry->loadArray($array['params']);
			$array['params'] = $registry->toString();
		}

		return parent::bind($array, $ignore);
	}

	function check()
	{
		if ( !preg_match('/^\w+=[\w\.]+(&\w+=[\w\.]+)*$/', trim($this->integrated_vars)) ) {
			$this->setError(JText::_('WARN_INVALID_INTEGRATED_VARS'));
			return false;
		}
		
		if ( !preg_match('/^\w+=[\w\.]+(&\w+=[\w\.]+)*$/', trim($this->checked_vars)) ) {
			$this->setError(JText::_('WARN_INVALID_CHECKED_VARS'));
			return false;
		}
		
		if ( !preg_match('/^\w+$/', trim($this->rel_item_id)) ) {
			$this->setError(JText::_('WARN_INVALID_RELATED_ITEM_ID'));
			return false;
		}
		
		$position = trim($this->position);
		if ( $position != 'before' && $position != 'after' && $position != 'inner') {
			$this->setError(JText::_('WARN_INVALID_POSITION'));
			return false;
		}
		
		$restore_fields = trim($this->restore_fields);
		$restore_fields = preg_replace('\s', '', $restore_fields);
		if ($restore_fields != '' && !preg_match('/^\w+(;\w+)*$/', $restore_fields)) {
			$this->setError(JText::_('WARN_INVALID_RESTORE_FIELDS'));
			return false;
		}
		
		return true;
	}
}