<?php
/**
 * @version		$Id$
 * @author		Nguyen Lu Vinh
 * @package		FunReCaptcha
 * @copyright	Copyright (C) 2009 All For You. All rights reserved.
 * @license		GNU/GPL
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class plgSystemFunReCaptcha extends JPlugin
{
	function __construct(& $subject, $config = array())
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}
	
	function onAfterRoute()
	{
		$app = &JFactory::getApplication();
		if ($app->isAdmin()) {
			return;
		}
		
		if (!JComponentHelper::isEnabled('com_funrecaptcha', true)) {
			return;
		}
		
		$funrecaptchaCheckers = $app->getUserState('plg.funrecaptchaCheckers');
		if (empty($funrecaptchaCheckers)) {
			return;
		}
		foreach ($funrecaptchaCheckers as $key => $item) {
			$vars = explode('&', $item->checked_vars);
			$match = true;
			for($i = 0, $n = count($vars); $i < $n; $i++) {
				list($var, $value) = explode('=', $vars[$i]);
				if (JRequest::getCmd($var, '') != $value) {
					$match = false;
					break;
				}
			}
			// check the recaptcha is it valid
			if ($match) {
				unset($funrecaptchaCheckers[$key]);
				$app->setUserState('plg.funrecaptchaCheckers', $funrecaptchaCheckers);
				if ($this->confirm()) {
					break;
				}
				$fields = explode(';', $item->restore_fields);
				$filler = array();
				$postData = JRequest::get('post');
				foreach ($fields as $field) {
					list($fieldId, $fieldName) = explode(':', $field);
					if ($fieldName == '') {
						$fieldName = $fieldId;
					}
					$fieldId = trim($fieldId);
					$fieldName = trim($fieldName);
					// if the field name is an array then get the data from the post array
					if (preg_match('/^(\w+)\[(.+)\]$/', $fieldName, $matches)) {
						$postValue = $postData[$matches[1]];
						// field name is multi array ex: temp[qwer][asdf][zxcv]
						$arrayKeys = explode('][', $matches[2]);
						foreach ($arrayKeys as $arrayKey) {
							$postValue = $postValue[$arrayKey];
						}
					} else {
						$postValue = $postData[$fieldName];
					}
					if ($postValue) {
						$filler[$fieldId] = $postValue;
					}
				}
				if (!empty($filler)) {
					$funrecaptchaFillers = $app->getUserState('plg.funrecaptchaFillers');
					$funrecaptchaFillers[$key] = $filler;
					$app->setUserState('plg.funrecaptchaFillers', $funrecaptchaFillers);
				}
				$app->redirect($item->url, JText::_('CAPTCHA_IS_WRONG'), 'error');
			}
		}
		return;
	}
	
	function onAfterRender()
	{
		$app = &JFactory::getApplication();
		// Only integrate reCaptcha in front-end only
		if ($app->isAdmin()) {
			return;
		}
		
		if (!JComponentHelper::isEnabled('com_funrecaptcha', true)) {
			return;
		}
		
		$document = &JFactory::getDocument();
		if ($document->getType() !== 'html') {
			return;
		}
		
		JModel::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_funrecaptcha'.DS.'models');
		$model = &JModel::getInstance('Items', 'FunReCaptchaModel');
		$model->setState('filter.enabled', 'T'); 
		$items = &$model->getData();
		// Checked the integrated variables of each funrecaptcha item
		for ($i = 0, $n = count($items); $i < $n; $i++) {
			$item = &$items[$i];
			$vars = explode('&', $item->integrated_vars);
			$match = true;
			for($j = 0, $m = count($vars); $j < $m; $j++) {
				list($key, $value) = explode('=', $vars[$i]);
				if (JRequest::getCmd($key, '') != $value) {
					$match = false;
					break;
				}
			}
			// Integrate the reCaptcha field to the form
			if ($match) {
				$key = 'item'.$item->id;
				$captcha = $this->_integrateField($item->rel_item_id, $item->position, $item->params);
				$captcha .= $this->_fillFormField($key);
				$body = JResponse::getBody();
				$body = str_ireplace('</BODY>', $captcha . '</body>', $body);
				JResponse::setBody($body);
				
				$uri = &JURI::getInstance();
				$funrecaptchaCheckers = $app->getUserState('plg.funrecaptchacCheckers');				
				$funrecaptchaCheckers[$key] = new stdClass();
				$funrecaptchaCheckers[$key]->url				= $uri->toString();
				$funrecaptchaCheckers[$key]->restore_fields	= $item->restore_fields;
				$funrecaptchaCheckers[$key]->checked_vars		= $item->checked_vars;
				
				$app->setUserState('plg.funrecaptchaCheckers', $funrecaptchaCheckers);
				break;
			}
		}
		return;
	}
	
	function _integrateField($relItemId, $position, $params = null)
	{
		ob_start();
		echo '<div id="funrecaptchaDiv">';
		echo $this->display($params);
		echo "</div>\n";
		echo "<script type=\"text/javascript\">\n";
		echo "window.addEvent('domready', function() {\n";
		echo "	var element = document.getElementById('funrecaptchaDiv');\n";
		echo "	var relItemId = document.getElementById('$relItemId');\n";
		echo "	if (relItemId) {\n";
		echo "		element.inject(relItemId, '".$position."')\n";
//		echo "		var parentElement = relItemId.parentNode;\n";
//		if ($position == 'before') {
//			echo "		parentElement.insertBefore(element, relItemId);\n";
//		} else if ($position == 'after') {
//			echo "		parentElement.insertBefore(element, relItemId.nextSibling);\n";
//		} else if ($position == 'inner') {
//			echo "		relItemId.appendChild(element);\n";
//		}
		echo "	}\n";
		echo "});\n";
		echo "</script>";
		$content = ob_get_clean();
		return $content;
	}
	
	function _fillFormField($key)
	{
		$app = &JFactory::getApplication();
		$funrecaptchaFillers = $app->getUserState('plg.funrecaptchaFillers');
		if (!empty($funrecaptchaFillers) && !empty($funrecaptchaFillers[$key])) {
			$js = "<script type=\"text/javascript\" src=\"".JURI::base()."plugins/system/funrecaptcha/js/jquery.js\"></script>\n";
			$filler = $funrecaptchaFillers[$key]; 
			$js .= "<script type=\"text/javascript\">\n";
			// $fields = explode(';', $funrecaptchaFillers[$key]);
//			$js .= "	filler = jQuery.parseJSON('".json_encode($filler)."');\n";
//			$js .= "	console.log(filler);";
			foreach ($filler as $fieldId => $value) {
				$js .= "	jQuery('#$fieldId').val(jQuery.parseJSON('".addslashes(json_encode($value))."'));\n";
				// $js .= "	document.getElementById('$fieldId').value = '$data';\n";
			}
			$js .= "	jQuery.noConflict(true);\n";
			$js .= "</script>\n";
			unset($funrecaptchaFillers[$key]);
			$app->setUserState('plg.funrecaptchaFillers', $funrecaptchaFillers);
			return $js;
		}
		return null;
	}
	
	function display($params = null)
	{
		$component =& JComponentHelper::getComponent('com_funrecaptcha');
		if (!$component) {
			return null;
		}
		$comParams = new JParameter($component->params);
		if (isset($params)) {
			$params = new JParameter($params);
			$comParams->merge($params);
			$params = &$comParams;
		} 
		$publicKey	= $params->get('public_key');
		$theme		= $params->get('theme');
		$lang		= $params->get('language');
		
		$content = "<script type=\"text/javascript\"> var RecaptchaOptions = { theme: '$theme', lang: '$lang', tabindex: 0 }; </script>";
		// Render reCaptcha widget
		require_once(JPATH_PLUGINS.DS.'system'.DS.'funrecaptcha'.DS.'recaptchalib.php'); 
		$content .= recaptcha_get_html($publicKey, null, JFactory::getURI()->isSSL());
		
		if ($params->get('show_audio_btn', 1) == 0) {
			$content .= "<script type=\"text/javascript\"> document.getElementById('recaptcha_switch_audio').style.visibility = 'hidden'; </script>";
		}
		
		if ($params->get('show_help_btn', 1) == 0) {
			$content .= "<script type=\"text/javascript\"> document.getElementById('recaptcha_whatsthis_btn').style.visibility = 'hidden'; </script>";
		}
		
		$customHelpURL = $params->get('help_url', '');
		if ($customHelpURL != '') {
			$content .= "<script type=\"text/javascript\"> 
				document.getElementById('recaptcha_whatsthis_btn').href='$customHelpURL'; 
				document.getElementById('recaptcha_whatsthis_btn').onclick=function() {  }; 
				document.getElementById('recaptcha_whatsthis').onclick=function() {  }; 
			</script>\n";
		}
		return $content;
	}
	
	function confirm($privateKey = null)
	{
		$component = &JComponentHelper::getComponent('com_funrecaptcha');
		if (!$component) {
			return false;
		}
		if (!$privateKey) {
			$params = new JParameter($component->params);
			$privateKey = $params->get('private_key');
		}
		require_once(JPATH_PLUGINS.DS.'system'.DS.'funrecaptcha'.DS.'recaptchalib.php');
		
		$resp = recaptcha_check_answer ( $privateKey, 
						 $_SERVER["REMOTE_ADDR"],
						 $_POST["recaptcha_challenge_field"],
						 $_POST["recaptcha_response_field"]);
		if (!$resp->is_valid) {
			return false;
		}
		return true;
	}
}